//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "mainUnit.h"
#include "connect_thread.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
	iActiveThreads = 0;
	iCurrentIP = 1;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnStartClick(TObject *Sender)
{
	tmrNewConnect->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::tmrNewConnectTimer(TObject *Sender)
{
	if(this->iActiveThreads >= MAX_THREADS)
		return;
	AnsiString scanAddress = edIpClass->Text+"."+IntToStr(iCurrentIP);
	TConnectThread *ct =
		new TConnectThread(scanAddress, edPort->Text, false);	//run after create
	if(ct)
	{
		this->iActiveThreads++;
		if(iCurrentIP < 254)
			iCurrentIP++;
		else
			tmrNewConnect->Enabled = false;
		StatusBar1->Panels->Items[0]->Text = scanAddress + "...";
		StatusBar1->Panels->Items[1]->Text = "Threads: " + IntToStr(iActiveThreads);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::ConnectThreadTerminated()
{
	frmMain->iActiveThreads--;
}